.586
.model flat, stdcall
option casemap:none
include windows.inc
include kernel32.inc
includelib kernel32.lib
include user32.inc
includelib user32.lib
include comctl32.inc
includelib comctl32.lib
include comdlg32.inc
includelib comdlg32.lib
include wsock32.inc
includelib wsock32.lib

;***************************************************************************************************

WinMain proto
WndProc proto hwnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

;***************************************************************************************************

IDI_ICON        equ 100
IDP_MENU        equ 200
IDM_WAIT        equ 211
IDM_EXIT        equ 219

WIN_WIDTH       equ 320
WIN_HEIGHT      equ 240

IDC_SBR1        equ 1004
MAXSIZE         equ 260

WM_SOCK         equ WM_USER+100

;***************************************************************************************************

.data
ClassName       db "sockey",0
AppName         db "Mmm",0

strAccept       db "Incoming connection",0
strConn         db "Connected",0
strRead         db "Data waiting to be read",0
strClose        db "Connection Closed",0
StrList         db "Ready to receive connections",0

errSock         db "Erreur de cration du socket",0

ListenPort      dd 2000     ;between 1024 and 5000 are general use ports

test1           db "Que?",13,10


.data?
hInstance       HINSTANCE   ?
hWnd            HWND        ?
hMenu           HMENU       ?
hStatus         HWND        ?

wsaData         WSADATA <?>
sin             sockaddr_in <?>
hListSock       SOCKET ?
hNewSock        SOCKET ?

.code
start:
    invoke GetModuleHandle, NULL
    mov hInstance,eax
    invoke WinMain
    invoke ExitProcess, eax

;***************************************************************************************************

WinMain proc
    LOCAL wc:WNDCLASSEX
    LOCAL msg:MSG
    push edi
    lea edi,[wc]
    assume edi:ptr WNDCLASSEX
    mov [edi].cbSize,SIZEOF wc
    mov [edi].style,CS_HREDRAW or CS_VREDRAW
    mov [edi].lpfnWndProc,OFFSET WndProc
    mov eax,hInstance
    mov [edi].hInstance,eax
    invoke LoadIcon, NULL,IDI_APPLICATION
    mov [edi].hIcon,eax
    invoke LoadCursor, NULL,IDC_ARROW
    mov [edi].hCursor,eax
    mov [edi].hbrBackground,COLOR_WINDOW+1
    mov [edi].lpszClassName,OFFSET ClassName
    xor eax,eax
    mov [edi].cbClsExtra,eax
    mov [edi].cbWndExtra,eax
    mov [edi].lpszMenuName,eax
    mov [edi].hIconSm,eax
    invoke LoadMenu, hInstance,IDP_MENU
    mov hMenu,eax
    invoke RegisterClassEx, edi
    invoke CreateWindowEx, NULL,ADDR ClassName,ADDR AppName,WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,CW_USEDEFAULT,WIN_WIDTH,WIN_HEIGHT,NULL,hMenu,hInstance,NULL
    .IF (eax)
        mov hWnd,eax
        invoke ShowWindow, hWnd,SW_SHOWDEFAULT
        invoke UpdateWindow, hWnd
        lea edi,[msg]
        assume edi:ptr MSG
        .WHILE TRUE
            xor eax,eax
            invoke GetMessage, edi,eax,eax,eax
            .BREAK .IF(!eax)
            invoke TranslateMessage, edi
            invoke DispatchMessage, edi
        .ENDW
        mov eax,[edi].wParam
    .ENDIF
    assume edi:nothing
    pop edi
    ret
WinMain endp

WndProc proc hwnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
    mov eax,uMsg
;-- WM_COMMAND -------------------------------------------------------------------------------------
    .IF (eax==WM_COMMAND)
        ;lParam is hWndCtl
        mov eax,wParam
        mov edx,eax
        and eax,0ffffh      ;item/control/accel ID
        shr edx,16          ;notification code (0=menu; 1=accelerator)
        .IF (eax==IDM_WAIT)
            invoke socket, AF_INET,SOCK_STREAM,0
            cmp eax,INVALID_SOCKET
            je @socket_error
            mov hListSock,eax
        
            invoke WSAAsyncSelect, hListSock,hwnd,WM_SOCK,FD_ACCEPT or FD_CONNECT or FD_READ or FD_CLOSE
            cmp eax,SOCKET_ERROR
            je @socket_error
        
            mov ax,AF_INET
            mov sin.sin_family,ax
            invoke htons,ListenPort
            mov sin.sin_port,ax
            mov eax,INADDR_ANY
            mov sin.sin_addr,eax
        
            invoke bind, hListSock,ADDR sin,SIZEOF sockaddr_in
            cmp eax,SOCKET_ERROR
            je @socket_error
        
            invoke listen, hListSock,1
            cmp eax,SOCKET_ERROR
            je @socket_error
        
            invoke SendMessage, hStatus,SB_SETTEXT,0,ADDR StrList
            jmp @okay
        
          @socket_error:
            invoke MessageBox, NULL,ADDR errSock,ADDR AppName,MB_ICONERROR

          @okay:
        .ELSEIF (eax==IDM_EXIT)
            invoke PostMessage, hwnd,WM_CLOSE,NULL,NULL
        .ENDIF
;-- WM_SOCK ----------------------------------------------------------------------------------------
    .ELSEIF (eax==WM_SOCK)
        mov eax,lParam
        mov edx,eax
        and eax,0ffffh  ;event
        shr edx,16      ;error code
        .IF (eax==FD_ACCEPT)
            .IF (!edx)
                ;someone is trying to connect, so we should accept it ;)
                invoke SendMessage, hStatus,SB_SETTEXT,0,ADDR strAccept
                invoke accept, hListSock,ADDR sin,NULL
                mov hNewSock,eax    ;the new socket for the incoming connection
                ;**send some data just to test
                invoke send, hNewSock,ADDR test1,SIZEOF test1,NULL
            .ELSE
                ;erreur
            .ENDIF
        .ELSEIF (eax==FD_CONNECT)
            .IF (!edx)
                ;Aucune erreur ne s'est produite donc on continue
                invoke SendMessage, hStatus,SB_SETTEXT,0,ADDR strConn
                ;***you will only receive this event notification if you open a connection to a host
                ;*** not if they try to connect to you (see FD_ACCEPT)
            .ELSE
                ;Une erreur s'est produite. Mettez votre routine de traitement d'erreurs ici
            .ENDIF
        .ELSEIF (eax==FD_READ)
            .IF (!edx)
                ;Aucune erreur ne s'est produite donc on continue
                invoke SendMessage, hStatus,SB_SETTEXT,0,ADDR strRead
            .ELSE
                ;Une erreur s'est produite. Mettez votre routine de traitement d'erreurs ici
            .ENDIF
        .ELSEIF (eax==FD_CLOSE)
            .IF (!edx)
                ;Aucune erreur ne s'est produite donc on continue
                invoke SendMessage, hStatus,SB_SETTEXT,0,ADDR strClose
            .ELSE
                ;Une erreur s'est produite. Mettez votre routine de traitement d'erreurs ici
            .ENDIF
        .ENDIF
;-- WM_SIZE ----------------------------------------------------------------------------------------
    .ELSEIF (eax==WM_SIZE)
        invoke SendMessage, hStatus,WM_SIZE,wParam,lParam
;-- WM_CREATE --------------------------------------------------------------------------------------
    .ELSEIF (eax==WM_CREATE)
        invoke InitCommonControls
        invoke CreateStatusWindow, WS_CHILD+WS_VISIBLE,NULL,hwnd,IDC_SBR1
        mov hStatus,eax
        invoke WSAStartup, 202h,addr wsaData
;-- WM_DESTROY -------------------------------------------------------------------------------------
    .ELSEIF (eax==WM_DESTROY)
        invoke WSACleanup
        invoke PostQuitMessage, NULL
;-- default ----------------------------------------------------------------------------------------
    .ELSE
        invoke DefWindowProc, hwnd,uMsg,wParam,lParam
        ret
    .ENDIF
    xor eax,eax
    ret
WndProc endp

end start
